"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports._rules = exports._rule = exports._ruleInverted = exports._ruleConditions = exports._ruleFields = exports._ruleSubject = exports._ruleAction = exports._appDomain = exports._localeCode = exports._userLogin = exports._modelInclude = exports._object = exports._boolean = exports._string = exports._idString = exports._id = exports.AppDomain = void 0;
const joi_1 = __importDefault(require("joi"));
const locale_1 = require("./locale");
var AppDomain;
(function (AppDomain) {
    AppDomain["MERCHANT"] = "MERCHANT";
    AppDomain["CONSUMER"] = "CONSUMER";
    AppDomain["ADMIN"] = "ADMIN";
    AppDomain["DEVICE"] = "DEVICE";
})(AppDomain = exports.AppDomain || (exports.AppDomain = {}));
exports._id = joi_1.default.number().strict();
exports._idString = joi_1.default.number();
exports._string = joi_1.default.string().trim();
exports._boolean = joi_1.default.boolean();
exports._object = joi_1.default.object();
exports._modelInclude = joi_1.default.alternatives().try(exports._boolean, exports._object);
exports._userLogin = joi_1.default.string().max(250);
exports._localeCode = joi_1.default.string()
    .trim()
    .valid(...Object.values(locale_1.LocaleCode));
exports._appDomain = joi_1.default.string()
    .trim()
    .valid(...Object.values(AppDomain));
exports._ruleAction = joi_1.default.string().trim();
exports._ruleSubject = joi_1.default.string().trim();
exports._ruleFields = joi_1.default.string().trim();
exports._ruleConditions = joi_1.default.object();
exports._ruleInverted = joi_1.default.boolean();
exports._rule = joi_1.default.object().keys({
    action: exports._ruleAction.required(),
    subject: exports._ruleSubject.required(),
    fields: exports._ruleFields,
    conditions: exports._ruleConditions,
    inverted: exports._ruleInverted
});
exports._rules = joi_1.default.array().items(exports._rule);
//# sourceMappingURL=type.js.map